<?php

namespace Hp\Patterns\Facade;

class Facade
{
    public function __construct(private ATM $atm, private Client $client)
    {
    }

    public function withdrawMoney(): void
    {
        $this->client->enterCard();

        $this->atm->acceptCard();
        $this->atm->waitForEnterAmount();

        $this->client->enterAmount(1000);

        $this->atm->checkBalance();
        $this->atm->giveOutMoney();
        $this->atm->acceptCard();

        $this->client->takeMoney();
        $this->client->takeCard();
    }
}