<?php

namespace Hp\Patterns\Observer;

use SplObserver;
use SplSubject;

class CardObserver implements SplObserver
{
    private array $updatedCards = [];

    public function update(SplSubject $subject): void
    {
        $this->updatedCards[] = $subject;
    }

    public function getSumUpdatedCards(): void
    {
        foreach ($this->updatedCards as $card) {
            echo $card->getAmount();
        }
    }
}